/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the TokenExchangePermission type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TokenExchangePermission{}

// TokenExchangePermission struct for TokenExchangePermission
type TokenExchangePermission struct {
	TargetRegistrationId  *string `json:"targetRegistrationId,omitempty"`
	AllowedRegistrationId *string `json:"allowedRegistrationId,omitempty"`
	Builtin               *bool   `json:"builtin,omitempty"`
}

// NewTokenExchangePermission instantiates a new TokenExchangePermission object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTokenExchangePermission() *TokenExchangePermission {
	this := TokenExchangePermission{}
	return &this
}

// NewTokenExchangePermissionWithDefaults instantiates a new TokenExchangePermission object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTokenExchangePermissionWithDefaults() *TokenExchangePermission {
	this := TokenExchangePermission{}
	return &this
}

// GetTargetRegistrationId returns the TargetRegistrationId field value if set, zero value otherwise.
func (o *TokenExchangePermission) GetTargetRegistrationId() string {
	if o == nil || IsNil(o.TargetRegistrationId) {
		var ret string
		return ret
	}
	return *o.TargetRegistrationId
}

// GetTargetRegistrationIdOk returns a tuple with the TargetRegistrationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TokenExchangePermission) GetTargetRegistrationIdOk() (*string, bool) {
	if o == nil || IsNil(o.TargetRegistrationId) {
		return nil, false
	}
	return o.TargetRegistrationId, true
}

// HasTargetRegistrationId returns a boolean if a field has been set.
func (o *TokenExchangePermission) HasTargetRegistrationId() bool {
	if o != nil && !IsNil(o.TargetRegistrationId) {
		return true
	}

	return false
}

// SetTargetRegistrationId gets a reference to the given string and assigns it to the TargetRegistrationId field.
func (o *TokenExchangePermission) SetTargetRegistrationId(v string) {
	o.TargetRegistrationId = &v
}

// GetAllowedRegistrationId returns the AllowedRegistrationId field value if set, zero value otherwise.
func (o *TokenExchangePermission) GetAllowedRegistrationId() string {
	if o == nil || IsNil(o.AllowedRegistrationId) {
		var ret string
		return ret
	}
	return *o.AllowedRegistrationId
}

// GetAllowedRegistrationIdOk returns a tuple with the AllowedRegistrationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TokenExchangePermission) GetAllowedRegistrationIdOk() (*string, bool) {
	if o == nil || IsNil(o.AllowedRegistrationId) {
		return nil, false
	}
	return o.AllowedRegistrationId, true
}

// HasAllowedRegistrationId returns a boolean if a field has been set.
func (o *TokenExchangePermission) HasAllowedRegistrationId() bool {
	if o != nil && !IsNil(o.AllowedRegistrationId) {
		return true
	}

	return false
}

// SetAllowedRegistrationId gets a reference to the given string and assigns it to the AllowedRegistrationId field.
func (o *TokenExchangePermission) SetAllowedRegistrationId(v string) {
	o.AllowedRegistrationId = &v
}

// GetBuiltin returns the Builtin field value if set, zero value otherwise.
func (o *TokenExchangePermission) GetBuiltin() bool {
	if o == nil || IsNil(o.Builtin) {
		var ret bool
		return ret
	}
	return *o.Builtin
}

// GetBuiltinOk returns a tuple with the Builtin field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TokenExchangePermission) GetBuiltinOk() (*bool, bool) {
	if o == nil || IsNil(o.Builtin) {
		return nil, false
	}
	return o.Builtin, true
}

// HasBuiltin returns a boolean if a field has been set.
func (o *TokenExchangePermission) HasBuiltin() bool {
	if o != nil && !IsNil(o.Builtin) {
		return true
	}

	return false
}

// SetBuiltin gets a reference to the given bool and assigns it to the Builtin field.
func (o *TokenExchangePermission) SetBuiltin(v bool) {
	o.Builtin = &v
}

func (o TokenExchangePermission) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TokenExchangePermission) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.TargetRegistrationId) {
		toSerialize["targetRegistrationId"] = o.TargetRegistrationId
	}
	if !IsNil(o.AllowedRegistrationId) {
		toSerialize["allowedRegistrationId"] = o.AllowedRegistrationId
	}
	if !IsNil(o.Builtin) {
		toSerialize["builtin"] = o.Builtin
	}
	return toSerialize, nil
}

type NullableTokenExchangePermission struct {
	value *TokenExchangePermission
	isSet bool
}

func (v NullableTokenExchangePermission) Get() *TokenExchangePermission {
	return v.value
}

func (v *NullableTokenExchangePermission) Set(val *TokenExchangePermission) {
	v.value = val
	v.isSet = true
}

func (v NullableTokenExchangePermission) IsSet() bool {
	return v.isSet
}

func (v *NullableTokenExchangePermission) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTokenExchangePermission(val *TokenExchangePermission) *NullableTokenExchangePermission {
	return &NullableTokenExchangePermission{value: val, isSet: true}
}

func (v NullableTokenExchangePermission) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTokenExchangePermission) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
